package com.rf.fileCrack.file.dao.model;

import com.rf.fileCrack.base.model.BaseEntity;
import lombok.*;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;

/**
 * @author zsy
 * @description:文件信息表
 * @date 2021/6/17 15:55
 */
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_file_info")
@EqualsAndHashCode(callSuper=true)
@org.hibernate.annotations.Table(appliesTo = "t_file_info", comment = "文件信息表")
public class FileEntity extends BaseEntity {

    @Column(name = "email", columnDefinition = "varchar(50)  not null  comment '邮箱'")
    private String email;

    @Column(name = "call_word", columnDefinition = "varchar(100) comment '提示词'")
    private String callWord;

    @Column(name = "password", columnDefinition = "varchar(32) comment '密码'")
    private String password;

    @Column(name = "file_path", columnDefinition = "varchar(255) comment  '文件路径'")
    private String filePath;

    @Column(name = "file_status", columnDefinition = "varchar(10) default '1' comment '文件状态：1--已入库未开始解密,2--解密中,3--已解密未通知（邮箱有问题）,4--已解密并通知'")
    private String fileStatus;

}
