package com.rf.fileCrack.security;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.security.SecureRandom;
import java.util.Base64;

/**
 * @author zzf
 * @description:
 * @date 2021/7/29 9:16
 */
public class DESede {
    private DESede() {

    }

    private static final String DESEDE_CHARSET_NAME = "UTF-8";

    private static final String DESEDE = "DESede";

    private static final String DES_CBC = "DESede/CBC/PKCS5Padding";

    public static final String DEFAULT_KEY = "240262447423713749922240";

    public static String DEFAULT_DESEDE_IV = "12345678";

    public static byte[] encrypt(byte[] key, byte[] ivByte, byte[] value) {
        try {

            SecureRandom sr = new SecureRandom();
            SecretKey securekey = new SecretKeySpec(key, DESEDE);
            IvParameterSpec iv = new IvParameterSpec(ivByte);
            Cipher cipher = Cipher.getInstance(DES_CBC);
            cipher.init(Cipher.ENCRYPT_MODE, securekey, iv, sr);

            return cipher.doFinal(value);

        } catch (Exception e) {

        }
        return null;
    }

    public static byte[] decrypt(byte[] key, byte[] ivByte, byte[] value) {
        try {

            SecureRandom sr = new SecureRandom();
            SecretKey securekey = new SecretKeySpec(key, DESEDE);
            IvParameterSpec iv = new IvParameterSpec(ivByte);
            Cipher cipher = Cipher.getInstance(DES_CBC);
            cipher.init(Cipher.DECRYPT_MODE, securekey, iv, sr);

            return cipher.doFinal(value);

        } catch (Exception e) {
            e.printStackTrace();
        }

        return null;
    }

    public static String base64Encode(String src) throws Exception {
        Base64.Encoder encoder = Base64.getEncoder();
        return encoder.encodeToString(src.getBytes(DESEDE_CHARSET_NAME));
    }

    public static String base64Encode(byte[] buff) throws Exception {
        Base64.Encoder encoder = Base64.getEncoder();
        return encoder.encodeToString(buff);
    }

    public static String base64Decode(String src) throws Exception {
        Base64.Decoder decoder = Base64.getDecoder();
        return new String(decoder.decode(src), DESEDE_CHARSET_NAME);
    }

    public static byte[] base64DecodeToBytes(String src) throws Exception {
        Base64.Decoder decoder = Base64.getDecoder();
        return decoder.decode(src);
    }


    public static String encryptString(String str) {
        try {
            byte[] encrypt = DESede.encrypt(DEFAULT_KEY.getBytes(), DEFAULT_DESEDE_IV.getBytes(), str.getBytes());
            String enStr = DESede.base64Encode(encrypt);
            return enStr;
        } catch (Exception e) {
            throw new IllegalArgumentException(e.getMessage());
        }
    }

    public static String decryptString(String str) {
        try {
            byte[] strBytes = DESede.base64DecodeToBytes(str);
            return new String(DESede.decrypt(DEFAULT_KEY.getBytes(), DEFAULT_DESEDE_IV.getBytes(), strBytes));
        } catch (Exception e) {
            throw new IllegalArgumentException(e.getMessage());
        }
    }

    public static void main(String[] args) {
    }
}
